// main js-code

var jsonw;
var params;

var actions = {
			base: {
			base_uri: "/MDService2/"
		},
		collections: {
			base_uri: "/MDService2/collections/",			
			current:'olac'},
		elements: {
				base_uri: "/MDService2/element/",			
				current:''},
		terms: {
			base_uri: "/MDService2/terms/",			
			current:'all',
			maxdepth: 8},
		terms_autocomplete: {
				base_uri: "/MDService2/terms/",			
				current:''},
		components: {
				base_uri: "/MDService2/comp/",				
				current:''},
				/* current:'cmdi-corpus-aac2'}, */		
		compprofiles: {
				base_uri: "/MDService2/compprofile/",				
					current:''},
					/* current:'cmdi-corpus-aac2'}, */		
				
		recordset: {
				base_uri: "/MDService2/recordset/"
				},

		isocat: {
				base_uri: "/MDService2/datcats/",
				current:5
				}

	};


$(function(){

		init();		
		loadWelcomeMessage();
		// Collections and terms loaded after WorkspaceProfile is loaded
		loadWorkspaceProfiles();
		//loadCollections();
		//loadTerms();
		//handleQueryInput();
		
		loadComponentsRegistry();	
		loadDCR();
		
		handleBubble();
	
		addFunctionality();
		addVisuals();
		
		//queryuriparams loaded after collections and workspaceprofile are loaded
		//loadQueryFromUriParams();
		
});


function init () {

	// turn on debugging (see jquery.xslTransform.js)
		var DEBUG = false;
		
	// check for jQuery and Sarissa
		try{
			jQuery;
		}catch(e){
			alert('You need to include jQuery!');
		}

//////////////		
		params = getUrlVars();
		createSearchClauses();
}

function update (uri, src_container, target_container,handler) {
	notifyUser("update-uri:" + uri,'debug');
	$(target_container).load(uri, handler );	
}
// TODO multiple collections
function submit_query (columns, query, squery) {
	notifyUser("processing query");
	
	if (jQuery.trim(query).length == 0){
		query = null;
	}
	if (jQuery.trim(squery).length == 0){
		squery = null;
	}
	
	var q = new Query(collections, columns, query, squery); //actions.collections.current, query );
	q.repository = getSelectedRepository();
	notifyUser("submit_query:" + q.query_uri(),'debug');
	queryset.addquery(q);
	//notifyUser("container" + q.container.attr('id'));
	//$("#querylist").append("sdfdsf");	
}

/* OBSOLETE? */
function handle_result (data, textStatus) {
	try {
	$(this).text("done");
  //$(this).html(data);
  notifyUser("query processed:" + textStatus);
	} catch (e) {
		notifyUser(e,'debug');
	}
}


function showNotifyMessages(){
	try {
		$('#notify-float').html($('#notify').html());
		var title = "Notify - Messages";
		$('#notify-float').dialog( "option", "title", title );
		
		//ui-state-default
		$('#notify-float').dialog('open');
		$('#notify-float').siblings('div.ui-dialog-titlebar').addClass('ui-state-default');
		$('#notify-float').siblings('div.ui-dialog-titlebar').children().remove();
		var x = '<span class="cmd cmd_del ui-dialog-titlebar-del "/><span class="cmd cmd_up ui-dialog-titlebar-up"/><span>' + title +'</span>';
		$('#notify-float').siblings('div.ui-dialog-titlebar').prepend(x);
		
		} catch (e) {
			notifyUser(e,'debug');
		}		
}

function showDetail(data, textStatus) {	
	try {
		//notifyUser("receiving data:",'debug');
		//notifyUser(data,'debug');
		
		$('#detail-float').html(data);
		var title =  $('#detail-float').find('.inner_title').attr("value");
		$('#detail-float').dialog( "option", "title", title );
		
		//ui-state-default
		
		$('#detail-float').dialog('open');
		$('#detail-float').siblings('div.ui-dialog-titlebar').addClass('ui-state-default');
		$('#detail-float').siblings('div.ui-dialog-titlebar').children().remove();
		var x = '<span class="cmd cmd_del ui-dialog-titlebar-del "/><span class="cmd cmd_up ui-dialog-titlebar-up"/><span>' + title +'</span>';
		$('#detail-float').siblings('div.ui-dialog-titlebar').prepend(x);
		
		notifyUser("query processed:" + textStatus);
		} catch (e) {
			notifyUser(e,'debug');
		}	
}

function showDetail2(data, textStatus) {	
	try {
		//notifyUser("receiving data:",'debug');
		//notifyUser(data,'debug');
		$('#detail').html(data);
	  //$(this).html(data);
		
	  notifyUser("query processed:" + textStatus);
		$("#detail .treeview").treeview({
			animated: "fast",
			collapsed: true
		});

		} catch (e) {
			notifyUser(e,'debug');
		}	
}

function getNotifyMessagesText(){
	var text = "";
	for(var i=0;i<notify_messages.length;i++){
		text = text  + "/n" + notify_messages[i].getText();
	}
	return text;
}
function notifyUser (msg) {
	var notifymessage = new NotifyMessage(new Date(),msg);	
	notifyset.add(notifymessage);
	  //notify_messages[notify_messages.length] = new NotifyMessage( new Date(),msg);
	  //$('#notify').text(msg);
	  //$('#notify').text(getNotifyMessagesText());
	  //$('#notify-all').find('textarea').attr("value",$('#notify-all').find('textarea').attr("value") + '\n' + msg);
}

function notifyUser (msg, type) {	
	
		if (type=='debug' & !(typeof console == "undefined")) {
			console.log(msg);
		} else {
			var notifymessage = new NotifyMessage(new Date(),msg);	
			notifyset.add(notifymessage);
			//notify_messages[notify_messages.length] = new NotifyMessage(new Date(),msg);
			//$('#notify').text(msg);	
			//$('#notify').text(getNotifyMessagesText());
			//$('#notify-all').find('textarea').attr("value",$('#notify-all').find('textarea').attr("value") + '\n' + msg);
	  }
}



function addToQuerylist (x) {	
	$("#querylist").prepend(x);	
}

function addToNotifylist (x) {	
	$("#notifylist").prepend(x);	
}


function addToSClist (div, i, j, rel) {	
	
	var x;
	
	//notifyUser(i + "," + j + "," + rel);
	if (rel == ""){
		x = $('<div />').addClass("sc-i").addClass("and_level");
		$(div).appendTo($(x).appendTo($('#searchclauselist')));
		$(x).attr("id",i);
	} else {
		if (rel == "and") {
			x = $('<div />').addClass("sc-i").addClass("and_level");
			$(x).attr("id",i);
			$(div).appendTo($(x).appendTo($('#searchclauselist')));
		} else {
			$(div).appendTo($('#searchclauselist').children()[i]);
		}
	}
	
	//$('#searchclauselist').append($(li));
	
}

var last_bubble_uri;


function showBubble (elem) {
  //get the position of the placeholder element
	notifyUser($(elem),'debug');
  var pos = $(elem).offset();  
  var width = $(elem).width();
  //show the menu directly over the placeholder
  //notifyUser(pos + width,'debug');
  $("#bubble").css( { "left": (pos.left + width) + "px", "top":pos.top + "px" } );
  $("#bubble").show();
}

function link(action,format,params) {
	var l = actions[action].base_uri + format;

	// default param is q
	if (params){
		if ( ! $.isArray(params)) {
			l += '/' + params;
		} else {
			l += '?' + $.param(params);
		}
	}
	notifyUser("l:"+ l,'debug');
	return l;
}

function  preprocessJSON(json){
	
	if (json["WorkspaceProfile"].Querysets[0] == undefined){
		var jj = json["WorkspaceProfile"]["Querysets"]["item"];
		delete json["WorkspaceProfile"]["Querysets"]["item"];
		json["WorkspaceProfile"]["Querysets"] = [{}];
		json["WorkspaceProfile"]["Querysets"][0] = jj;
		}
	if (String(json["WorkspaceProfile"]["Querysets"]) != "null") {
		
		$.each(json["WorkspaceProfile"]["Querysets"], function(i,item) {
		    if (this.Queries[0] == undefined){
		    	var jj = this["Queries"]["item"];
				delete this["Queries"]["item"];
				this.Queries = [{}];
		    	this.Queries[0] = jj;
		    }
		});
		
		$.each(json["WorkspaceProfile"]["Querysets"], function(i,item){
			if (String(this.Queries) != "null") {
				$.each(this.Queries, function(i,item){
					if (this.collections != "null") {
						if (this.collections[0] == undefined){
					    	var jj = this["collections"]["item"];
							delete this["collections"]["item"];
							this.collections = [{}];
					    	this.collections[0] = jj;
					    }
					}
					if (this.columns != "null") {
						if (this.columns[0] == undefined){
					    	var jj = this["columns"]["item"];
							delete this["columns"]["item"];
							this.columns = [{}];
					    	this.columns[0] = jj;
					    }
					}
				});
			}
		});
	}
	
	return json;
	
}
function appendQueryUI(json,i, qs){
	var del = '';
	var name = '';
	//var ul;
	var id = $(qs).parent().attr('id');

	/*
	if ($(qs).find('ul').size() == 0) {
		ul = $('<ul></ul>');
		$(ul).appendTo($(qs));
	} else {
		ul = $(qs).children('ul');
	}	 
	 
	var x = '<li><span class="query_detail_caller" ><a href="'+id + '_'+ i+'" >' + 
	Query.fullformatstring(json) + '</a></span><span class="cmd cmd_load"></span>' + 
	del +
	'<div class="term_detail" >' +
	'<ul><li><div class="elem text"><span class="elem_name">query:<span><span class="elem_value">' + Query.simplequerystring(json.querystring)+
	'</span></div></li><li><div class="elem text"><span class="elem_name">collections:</span><span class="elem_value">' + Query.collectiontext(json) + '</span></div></li></ul></div></li>';
	*/
	
	if (id == 'userqs') {
		del = '<span class="cmd cmd_del" ><xsl:text> </xsl:text></span>';
		name = '<div class="cmds-elem-prop"><span class="label">name:</span><input type="text" class="input-name" value="' + json.name + '"></div>';
	} else {
		name = '<div class="cmds-elem-prop"><span class="label">name:</span><span class="value">' + json.name +
		'</span></div>';
	}
	var x = '<div class="cmds-elem-plus" ><span class="cmd cmd_load"></span><span class="detail-caller" ><a href="'+id + '_'+ i+'" >' + 
	json.name + '</a></span>' + 
	del +
	'<div class="detail" >' +
	name +
	'<div class="cmds-elem-prop"><span class="label">squery:</span><span class="value">' + json.squerystring +
	'</span></div>' +
	'<div class="cmds-elem-prop"><span class="label">query:</span><span class="value">' + Query.simplequerystring(json.querystring) +
	'</span></div><div class="cmds-elem-prop"><span class="label">collections:</span><span class="value">' + Query.collectiontext(json) + '</span></div>' +
	'</div>';
	
	$(qs).append(x);
	
	
	$(qs).find('.input-name').keydown(function(ev){
		var evStop = function(){ 
			ev.stopPropagation(); 
			ev.preventDefault(); 
		};
		if (ev.which === 13) {
			var id = parseInt( $("#serverqts_select option:selected").val());
			$(this).parent().parent().parent().find('a').text($(this).val());
			var str = $(this).parent().parent().parent().find('a').attr("href");
			var iq = parseInt(str.substring(7));
			jsonw["WorkspaceProfile"]["Querysets"][id]["Queries"][iq].name = $(this).val();
			saveWorkspace("USER");
			evStop();
		}
	});
}

function createQueriesUI(json, qs){
	$(qs).children().remove();
	if (json.Queries != "null") {
		$.each(json.Queries, function(i,item) {
			if (this != "null"){
				appendQueryUI(this,i, qs);
			}
		});
	}
	
}

function loadRepositories(json) {
	
	var $select;
	$select = $('#repositories_select');
	
	
	$select.find("option").remove();
	
	if (String(json) != "null") {
		
		$.each(json, function(i,item) {
		    $select.append(new Option(this.name, this.id));
		});
		
	}
	// select first
	if (params["repository"] != undefined){
		var r = parseInt(params["repository"])-1;
		$($select.find("option")[r]).attr("selected","true");
	} else {
		$select.find("option").first().attr("selected","true");
	}

	
	$select.change(function(data){
		loadCollections(false);				
		//loadTerms();
		handleQueryInput();
		$('#model_profiles').load(link('terms','htmlselect',actions.terms.current) + '?repository=' + getSelectedRepository());
	});
	
}

function getSelectedRepository(){
	//var id = parseInt($('#repositories_select').find("option:selected").val());
	return $('#repositories_select').find("option:selected").val();

}

function loadQuerysets(json, type) {
	
	var $select;
	if (type == "user") {
		$select = $('#qts_select');
	} else {
		$select = $('#serverqts_select');
	}
	
	$select.find("option").remove();
	
	if (String(json) != "null") {
		
		$.each(json, function(i,item) {
			//notifyUser(i + ',' + this.name + ',' + this.created,'debug');
		    $select.append(new Option(this.name, i));
		});
		
		
		// find id of selected
		if ($select.find("option").size() > 0) {
			$select.find("option").first().attr("selected","true");
			var id = parseInt($select.find("option:selected").val());
			var jsonq = json[id];
			
			if (type == "user") {
				$('#qts_input').val(jsonq["name"]);
				qs = $("#userqueries");
			} else {
				qs = $("#serverqueries");
			}
			createQueriesUI(jsonq, qs);
		}
		
		$select.change(function(data){
			if ($select.find("option").size() > 0) {
				// find id of selected
				var id = parseInt($select.find("option:selected").val());
				var jsonq = json[id];
				
				if (type == "user") {
					$('#qts_input').val(jsonq["name"]);
					qs = $("#userqueries");
				} else {
					qs = $("#serverqueries");
				}
				createQueriesUI(jsonq, qs);
				
/*			$('#qs_select').find("option").remove();
				
				if (String(jsonw["WorkspaceProfile"].Querysets[id].Queries) != "null") {
					$.each(jsonw["WorkspaceProfile"].Querysets[id].Queries, function(i,item) {
					
						notifyUser(i + ',' + this.querystring + ',' + this.collections[0],'debug');
						$('#qs_select').append(new Option(Query.simplequerystring(this.querystring) , i));
					});
				}
				*/
			}
	     });
	}
	

}

function saveWorkspace(type){

	var JSONText = JSON.stringify(jsonw["WorkspaceProfile"]);
	//var JSONText = JSON.stringify({"aa.a":"r"});
	//notifyUser(JSONText,'debug');
	$.post("/MDService2/workspaceprofilesave/" + type,{"data":JSONText});
	
}
////////////////////////////////////////////////
function loadWelcomeMessage(){	
	$('#detail').load("/MDService2/static/welcome.xml", function() { //profile.collections.base_uri,
		$('#welcome').addClass("ui-helper-reset ui-corner-all ui-widget-content");
		if ($("#querylist").children().size() > 0) {
			hideWelcomeMessage();
		}
	});
}

function hideWelcomeMessage(){
	// kick the welcome message on first submit
	notifyUser("hiding welcome");
	if( $('#welcome').is(':visible') ) {
		$('#welcome').hide();
	}
}

function loadWorkspaceProfiles(){
	//empty json
	jsonw = {'WorkspaceProfile':{'Termsets':'null','Repositories':'null','Querysets':'null','created':'null','lastchanged':'null','profilename':'null'}};
	$('#qts_input').val("");
	
	
	jQuery.getJSON("/MDService2/workspaceprofile/server",function(data){
		notifyUser(data['WorkspaceProfile'],'debug');
				var json = preprocessJSON(data);
				$("#serverqs").attr("data",JSON.stringify(json));
				loadQuerysets(json["WorkspaceProfile"]["Querysets"],"server");
				loadRepositories(json["WorkspaceProfile"]["Repositories"]);
				
				loadCollections(true);				
				loadTerms();
				handleQueryInput();
		});

	// USER WORKSPACEPROFILE
	jQuery.getJSON("/MDService2/workspaceprofile/user",function(data){
		notifyUser(data['WorkspaceProfile'],'debug');
				jsonw = preprocessJSON(data);
				loadQuerysets(jsonw["WorkspaceProfile"]["Querysets"],"user");
	});

}
function loadCollections(ini){
	
	$('#collections').load(link('collections','htmllist?repository=' + getSelectedRepository()), //profile.collections.base_uri,
			function() {
		
					if (ini) {
						loadQueryFromUriParams();
					}
					
					
					$("#collections .treeview").treeview({
						animated: "fast",
						collapsed: true
					});
					
					$(".treeview","#collections").find(".showselection").css("color","white");
	
					// handle treeview click
					$(".treeview","#collections").find(".selection").click(function() {
						var checked_status = this.checked;
						
						// select or deselect all children according to parent
						$(this).next().next().next().find(".selection").attr("checked",checked_status);
						$(this).next().next().next().find(".selection").attr("child","undefined");	
					
						// deselect parents
						if (checked_status===false){
							$(this).parent().parents("li").each(function(){
								$(this).children(".selection").attr("checked",false);
							});
						}
					
						
						// refresh sign of existent selection
						// first reset childrens settings
						$(this).next().next().next().find(".showselection").css("color","white");
						$(this).next().next().next().find(".showselection").attr("some_selection","0");
						
						// then refresh selections
						$(this).parents("li").each(function(){
							var count_selected = $(this).find("ul li .selection:checked").size();
							if (count_selected > 0){
								$(this).children(".showselection").attr("some_selection","1");//css("color","red");
						    } else {
								$(this).children(".showselection").attr("some_selection","0");//css("color","white");
						    }
							//TODO move into .css
							if (count_selected > 0){
									$(this).children(".showselection").css("color","red");
							} else {
									$(this).children(".showselection").css("color","white");
							}
							$(this).children(".showselection").attr("count",count_selected);
						});
							
						// uncheck parents node + param settings
						$(this).parent().parents("li").each(function(){
								$(this).find(".selection").attr("child","undefined");
								$(this).children(".selection").attr("checked",false);
						});

						// sett the parent_selection attr
						$(this).parents("li").each(function(){
							$(this).find(".selection").each(function(){
								if (($(this).attr("checked")===true) &&
									(($(this).parent().parent().parent().children(".selection").attr("checked")===false) ||
											($(this).parent().parent().parent().children(".treeview").size() == 1))
									){
									$(this).attr("child","parent_selection");
									}
							});					
						});
						
						// update collection_selection
						var $treeview = $(".treeview","#collections");
						//var collection = $("li",$treeview).find("input:checked[child='parent_selection']").next().text();
						//notifyUser("collection:" + collection,'debug');
						

						var collection_text = "";
						var coll;
						collections.splice(0, collections.length);
						$("li",$treeview).find("input:checked[child='parent_selection']").next().each(function(index){
							notifyUser("selection...:" + index + ":" + this.textContent  + $(this).attr("handle"),'debug');	
							coll = new Collection($(this).attr("handle"), this.textContent);
							collections[collections.length] = coll;
							/*
							if (index == 0) {
								collection_text = this.textContent;
							} else {
								collection_text = collection_text + ", " + this.textContent;
							}
							*/
						
						});
						//$('#collection_list').attr("value",collection_text);
						collections_widget.load(collections);
						
					});// end of treeview click
	});// end of collection callback	
}
function loadTerms(){
	
	//$('#model_profiles').load(link('terms','htmlselect',actions.terms.current));// + '?repository=' + getSelectedRepository());
	$('#model_profiles').load(link('terms','htmlselect',actions.terms.current) + '?repository=' + getSelectedRepository());
	
	$('#terms-select').live('change', function(event) {
		//notifyUser(this.value,'debug');
		update(link('terms', 'htmllist', this.value)+ '?maxdepth=' + actions.terms.maxdepth + '&repository=' + getSelectedRepository(), 
				'#terms-select', '#model_terms',
					function() {
						$("#model_terms .treeview").treeview({
							animated: "fast",
							collapsed: false
						});
						//notifyUser($("#model_terms .treeview"),'debug');
						notifyUser("loaded: #model_terms .treeview",'debug');
						}	
			);	
		}
	);
	
	$('#terms .cmd_filter').live('click',  function(event) {			
		//var term = $(this).parent().find('span.term_detail_caller a').text();
		var term = $(this).parent().children('span.data').text();		
		if ($('.searchtype_text','#search').size()> 0 ) {
			var t = $('#query_area').text();
			$('#query_area').val(t + " " + term);
		} else {
			searchclauseset.updatedata(term);
			
		}
		//$('#srquery').val(term);
	});
	
	$('#terms .cmd_columns').live('click',  function(event) {	
		//var term = $(this).parent().find('span.term_detail_caller a').text();
		var term = $(this).parent().children('span.data').text();
		// old method
		/*
		var columns_text = $('#columns_list').attr("value");
		if (columns_text.length > 0){
			columns_text = columns_text + ",";
		}
		columns_text = columns_text + term;
		$('#columns_list').attr("value",columns_text);
		*/
		//
		columns_widget.add(new ListItem(term));
//		columnset.addcolumn(new Column(term)); 
		
	});	
	
	/*
	 * deactivated -> obsolete?
	 * 
	$('#terms .cmd_detail').live('click',  function(event) {
		//showTermDetail($(this).parent().text());			
//			notifyUser($(this).parent().find('span.term_detail_caller a').text(),'debug');
		var term = 	$(this).parent().find('span.term_detail_caller a').text();
		var uri = link('terms', 'htmltable', term); // + " body";		
		
	//	 $.ajax({ 
	//		url: uri,
	//		success: showDetail
	//		}); 
		$.get(uri, showDetail,'html');
		
	});
	*/
}
function loadComponentsRegistry(){
	$('#profiles').load(link('compprofiles','htmlselect'));
	
	$('#components a').live('click', function (event) {
		event.preventDefault();		
		update($(this).attr('href'), '#components', '#components');
	});

	$('#profile-select').live('change', function(event) {
		//notifyUser(this.value,'debug');
		update(link('compprofiles', 'htmllist', this.value), 
				'#profile-select', '#components',
					function() {
						$("#components .treeview").treeview({
							animated: "fast",
							collapsed: false
						});
						notifyUser($("#components .treeview"),'debug');
						}	
			);	
		}
	);
	
	$('#components .cmd_filter').live('click',  function(event) {	
		var term = $(this).prev().text();
		if ($('.searchtype_text','#search').size()> 0 ) {
			var t = $('#query_area').text();
			$('#query_area').val(t + " " + term);
		} else {
			searchclauseset.updatedata(term);
			//$('.focused','#searchclauselist').find('.index_input').val(term);
		}
		//$('#srquery').val($(this).parent().children('a').attr('href'));
	});
	
	$('#compreg .cmd_detail').live('click',  function(event) {
		//showTermDetail($(this).parent().text());
		
		var uri = $(this).parent().children('a').attr('href'); // + " body";		
		// $.ajax({ 
		//	url: uri,
		//	success: showDetail2
		//	});
			
		$.get(uri, showDetail2,'html');

	});

}
function loadDCR(){
	
	// ISOCAT DCR
	 $('#dcr').load(link('isocat', 'htmllist', actions.isocat.current) );

	 // display minimal info in a bubble next to the calling anchor
	 $("#dcr a, .comp_detail a").live('click', 
				function (event) {
					event.preventDefault();
				
					var uri = $(this).attr('href');
					$('#bubble').empty();
					// weirdly not functioning
					var isVisible = $('#bubble').is(':visible');
					if (uri==last_bubble_uri) {						
						$('#bubble').hide();
						last_bubble_uri = '';
					} else {						
						notifyUser("conceptlink_uri: " + uri,'debug');						
						$('#bubble').load(uri);
						last_bubble_uri = uri;
						showBubble($(this));	
					}
					notifyUser('last_bubble_uri:' + last_bubble_uri,'debug');
					
					//TODO filter, read isocat:nr
					// use in query clause
					var term = $(this).val();
					var x = uri.split("/");
					var category = x[x.length-1];
					notifyUser(term);
					searchclauseset.updatedata(term, true, category);
				}); 
}

function handleQueryInput(){
	
	var elem;
	$('#terms_autocomplete').children().remove();
	$('#terms_autocomplete').css('display','none');
	$('#terms_autocomplete').load(link('terms_autocomplete','autocomplete/?q=all&repository='+ getSelectedRepository()),function(){
		$(this).find('term').each(function(index){
			elem = $(this).attr("name");
			element_autocomplete[index] = elem;
			elements_hashtable[elem] = $(this).html();
		});
		// add autocomplete 's
		searchclauseset.initAutocomplete();
		columns_widget.initAutocomplete(element_autocomplete);
		/*
		createSearchClauses();
		$('#query_list').css('display', 'none');
		 $('<div id="searchclauselist"/>').insertAfter($('#query_list'));

		var sc = new SearchClause("","","");
		searchclauseset.addsearchclause(sc,"",0,0);

		 // $('#query_area').hide();
		 $('#searchclauselist').show();
		 $('#toggle_inputmode_cmd').addClass("searchtype_clauses");
		 
		 $('#toggle_inputmode_cmd').live('click',function(){
			 if ($(this).text() == "TEXT") {
				 searchclauseset.buildsctext();
				 $('#query_area').val(searchclauseset.sctext);
				 $('#query_area').show();
				 $('#searchclauselist').hide();
				 $(this).toggleClass('searchtype_text searchtype_clauses');	
				 $(this).text("FORM");
			 } else {
				 $('#query_area').hide();
				 $('#searchclauselist').show();
				 $(this).text("TEXT");
				 $(this).toggleClass('searchtype_text searchtype_clauses');
			 }
		 });
		 
		 // load query if exists params
		 loadQueryFromUriParams();
		 */
	});
	
	 

};
//create searchclauses, columns and collections
function createSearchClauses() {
	$('#query_list').css('display', 'none');
	 $('<div id="searchclauselist"/>').insertAfter($('#query_list'));

	var sc = new SearchClause("","","");
	searchclauseset.addsearchclause(sc,"",0,0);

	 // $('#query_area').hide();
	 $('#searchclauselist').show();
	 $('#toggle_inputmode_cmd').addClass("searchtype_clauses");
	 
	 $('#toggle_inputmode_cmd').live('click',function(){
		 if ($(this).text() == "TEXT") {
			 searchclauseset.buildsctext();
			 $('#query_area').val(searchclauseset.sctext);
			 $('#query_area').show();
			 $('#searchclauselist').hide();
			 $(this).toggleClass('searchtype_text searchtype_clauses');	
			 $(this).text("FORM");
		 } else {
			 $('#query_area').hide();
			 $('#searchclauselist').show();
			 $(this).text("TEXT");
			 $(this).toggleClass('searchtype_text searchtype_clauses');
		 }
	 });
	 
	 // load query if exists params
	 //loadQueryFromUriParams();
	 
	 // create columnswidget
	 columns_widget = new ListWidget($('#columns-widget'));
	 
	 // create collectionswidget
	 collections_widget = new ListWidget($('#collections-widget'));
};

function loadQueryFromUriParams(){
	
	var q = params["q"];
	var squery = params["squery"];
	var collection = params["collection"];
	var startRecord = params["startRecords"];
	var numRecords = params["numRecords"];
	var repository = params["repository"];
	var columns = params["columns"];
	if ((q != undefined) || (squery != undefined) || (collection != undefined)) {
		if (q == undefined) {
			q = "";
		} else {
			q = Url.decode(q);
		}
		if (squery == undefined) {
			squery = "";
		} 
		if (columns == undefined) {
			columns = "";
		}
		if (startRecord == undefined) {
			startRecord = 1;
		}
		if (numRecords == undefined) {
			numRecords = 10;
		}
		if (repository == undefined) {
			repository = 1;
		}
		if (collection == undefined){
			collection = "";
		}
		var collections = [];
		if (collection.length > 0 ){
			var coll = collection.split(",");
			$.each(coll,function(i,item){
					var n;
					n = $('#collections').find(".folder:[handle='"+item+"']").text();
					var simple_collection = new Collection(item, n);
					collections[i] = simple_collection;
			});
		}
		
		var query = new Query(collections, columns, q, squery);
		query.startRecord = startRecord;
		query.numRecords = numRecords;
		query.repository = repository;
		
		
		queryset.addquery(query);
		
		searchclauseset.sctext = query.query;
		notifyUser(searchclauseset.sctext,'debug');
		
		searchclauseset.buildfromquerystring();

		$('#collection_list').attr("value",query.getcollectiontext("name"));
		columns_widget.load(query.columns);
		//$('#columns_list').attr("value",query.columns);
		$('#input-simplequery').attr("value",query.squery);	

		$('#query-input .content').show();
				                                         
		hideWelcomeMessage();
	}
	
}

function handleBubble(){
	// this is dangerous workaround
	// actually I want it only for context-paths in #terms, 
	// but they are moved out of the '.term_detail' context into the #bubble
	// so I have to use the generic..
	// well, dangerous - you might wonder, why the links don't work..
	$('#bubble a').live('click',  function(event) {
		//showTermDetail($(this).parent().text());
		event.preventDefault();
	} );
	
	
	$('#bubble .cmd_filter').live('click',  function(event) {	
		var term = $(this).next().next().attr("href");
		if ($('.searchtype_text','#search').size()> 0 ) {
			var t = $('#query_area').text();
			$('#query_area').val(t + " " + term);
		} else {
			$('.focused','#searchclauselist').find('.index-input').val(term);
		}
		//$('#srquery').val(term);
	});
	
	/* obsolete: ? */
	/* $(".term_detail_caller a, .query-detail-caller a").live('click',
				// function(event) {
				//	//notifyUser("term_detail_caller_live_click",'debug');					
				//	event.preventDefault();
				//	$(this).parents('li').find('div.term_detail').toggle();
	  		//}); 
	  		function (event) {
					event.preventDefault();
					var uri = $(this).attr('href');
					$('#bubble').empty();
					// weirdly not functioning
//					var isVisible = $('#bubble').is(':visible');
					if (uri==last_bubble_uri) {						
						$('#bubble').hide();
						last_bubble_uri = '';
					} else {		
						
						notifyUser("term_uri: " + uri,'debug');						
						var detail_info = $(this).parents('li').find('div.term_detail').html();
						$('#bubble').html(detail_info);
						last_bubble_uri = uri;
						showBubble($(this));	
					}
					notifyUser('last_bubble_uri:' + last_bubble_uri,'debug');
				});
	 		*/

}

function addFunctionality(){
	  
/*	$('.cmds-elem-plus').live('click',  function(event) {
		$(this).children('.detail').toggle();
	});
	*/ 
	$('.autocomplete-select-caller').live('click',  function(event) {
		
		$(this).closest(".index-context").prev().parent().find(".autocomplete-input").val($(this).text());
		$(this).closest(".index-context").hide();
	});
	$('.autocomplete-select-caller a').live('click',  function(event) {		
		event.preventDefault();
	});
	$('.detail-caller, .cmd_detail').live('click',  function(event) {		
		$(this).parent().children('.detail').toggle();
		$(this).children('.cmd_down, .cmd_up').toggleClass('cmd_down cmd_up');		
	});
	
	$('.detail-caller a').live('click',  function(event) {		
		event.preventDefault();
	});
	
	$('.comp_detail input').live('keyup',  function(event) {			
		$('#srquery').val(
				$(this).parent().children('span.cmdelem_name').text()
				+ "=" + $(this).val() );
	});
	
	// open detail (from result-set, but also already within detail-view (ResourceRef, IsPartOf)	
	$('.result a.internal, .mdrecord-detail a.internal').live('click',  function(event) {
		event.preventDefault();		
		
		var uri = $(this).attr('href'); // + " body";
		notifyUser('internal-link: ' + uri,'debug' );
		$.get(uri, showDetail,'html');
	});

	$('.result a.external, .mdrecord-detail a.external').live('click',  function(event) {
		
		//event.preventDefault();		
		var uri = $(this).attr('href'); // + " body";
		notifyUser('resource-link: ' + uri,'debug' );
	//	$.get(uri, showDetail,'html'); */
	});
	
	$('.result .cmd_detail').live('click',  function(event) {	
	
		var uri = $(this).parent().find("a").attr('href'); // + " body";
		$.get(uri, showDetail,'html');
	});
	
// RECORDSET searchRetrieve
	$('#searchretrieve').submit( function(event) {
			event.preventDefault();
			hideWelcomeMessage();
			searchclauseset.buildsctext();
			notifyUser(searchclauseset.sctext,'debug');
			//submit_query ($('#columns_list').attr("value"),searchclauseset.sctext, $('#input-simplequery').attr("value"));			
			submit_query (columns_widget.getColumnsListText(),searchclauseset.sctext, $('#input-simplequery').attr("value"));
	});

	/*
	$('#querylist .query_header').find('.cmd_del').live('click',  function(event) {
		//showTermDetail($(this).parent().text());
		
		queryset.removequery($(this).closest('.query_wrapper').attr('id'));
					
	});
*/
	
	$('#querylist .cmd_up').live('click',  function(event) {
		$(this).closest('.query_wrapper').find('.result').hide();
		$(this).toggleClass('cmd_down cmd_up');					
	});

	
	$('#querylist .cmd_save').live('click',  function(event) {
		
		var qid = "";
		var qstring = "";	
		var json_coll = "null";
		var json_cols = "null";
		var squery = "";
		var bookmark = "0";
		
		if ($(this).parents('.result').length > 0){
			qstring = $(this).parent().find("a").attr('href');
			qstring = qstring.substring(18,qstring.length);
			bookmark = "1";
		} else {
			qid = $(this).closest('.query_wrapper').attr("id");
			qstring = queryset.getquerystring(qid);	
			json_coll = queryset.getcollections(qid);
			json_cols = queryset.getcolumns(qid);
			squery = queryset.getsquery(qid);
		}
		 
		// JSON conversion
		if (qstring.length == 0){
			qstring = "[NULL]";
		}
		if (squery.length == 0){
			squery = "[NULL]";
		}

		var id = parseInt($("#qts_select option:selected").val());
		var iq = $('#userqueries').children().size();
	
		if (iq == 0){
			jsonw["WorkspaceProfile"]["Querysets"][id]["Queries"] = [{}];
		}
		var jsonq = {"name":"", "squerystring":squery, "querystring":qstring,"searchclauses":"null" , "collections" : json_coll, "columns" : json_cols, "bookmark" : bookmark};
		
		var name;
		if (bookmark == "1") {
			qstring = Url.decode(qstring);
			var s = qstring.split(':');
			name = s[s.length - 2] + ":" + s[s.length - 1];
		} else {
			name = Query.fullformatstring(jsonq);
		}
		jsonq.name = name;
		
		jsonw["WorkspaceProfile"]["Querysets"][id]["Queries"][iq] = jsonq;
		saveWorkspace("USER");
		appendQueryUI(jsonw["WorkspaceProfile"]["Querysets"][id]["Queries"][iq],iq, $('#userqueries'));
		
		//$("#qs_select").append(new Option(Query.simplequerystring(qstring),iq));
	});
	
	$('#querylist .cmd-xml').live('click',  function(event) {
		var qid = $(this).closest('.query_wrapper').attr("id");

		queryset.getQuery(qid).open('xml');
	});
	$('#querylist .cmd-page').live('click',  function(event) {
		var qid = $(this).closest('.query_wrapper').attr("id");

		queryset.getQuery(qid).open('htmlpage');
	});
	/*
	$('#querylist .cmd-link').live('click',  function(event) {
		/* var qid = $(this).closest('.query_wrapper').attr("id");
		var qstring = queryset.getquerystring(qid);	
		var json_coll = queryset.getcollections(qid);
		var json_cols = queryset.getcolumns(qid);
		var squery = queryset.getsquery(qid);
		// JSON conversion
		if (qstring.length == 0){
			qstring = "[NULL]";
		}
		if (squery.length == 0){
			squery = "[NULL]";
		}		
		var jsonq = {"squerystring":squery, "querystring":qstring,"searchclauses":"null" , "collections" : json_coll, "columns" : json_cols};
		///
		
		queryset.getQuery(qid).open();
	});
	*/
	/*
	$('.cmd_select').live('click',  function(event) {
		var qid = $(this).closest('.query_wrapper').attr("id");
					
		searchclauseset.sctext = queryset.getquerystring(qid);
		searchclauseset.buildfromquerystring();
	});
	*/
	$('#queryslist .cmd_reload').live('click',  function(event) {
		var qid = $(this).closest('.query_wrapper').attr("id");

		queryset.resubmit(qid);
		
	});
		
	
	$('.cmd_down').live('click',  function(event) {	
		$(this).closest('.query_wrapper').find('.result').show();
		$(this).toggleClass('cmd_down cmd_up');					
	});
	$('.cmd_sc_delete').live('click',  function(event) {
		var i = $(this).closest('.sc-i').attr('id');
		var j = $(this).closest('.sc-j').attr('id');
		//notifyUser(i + j,'debug');
		searchclauseset.removesearchclause(i,j);
					
	});
	$('.cmd_add_and').live('click',  function(event) {
		//showTermDetail($(this).parent().text());
		//$(this).next().hide();
		$(this).attr("value","AND");
		var searchclause = new SearchClause("","","");
		var i = $(this).closest('.sc-i').attr('id');
		var j = $(this).closest('.sc-j').attr('id');
		//notifyUser(i + j,'debug');
		searchclauseset.addsearchclause(searchclause,"and",i,j);
					
	});
	$('.cmd_add_or').live('click',  function(event) {
		//showTermDetail($(this).parent().text());
		//$(this).next().hide();
		var i,j;
		$(this).attr("value","OR");
		var searchclause = new SearchClause("","","");
		searchclauseset.addsearchclause(searchclause,"or",$(this).closest('.sc-i').attr('id'),$(this).closest('.sc-j').attr('id'));
					
	});

	///// datasets/queries
	$('#qts_save').click(function(){
		var id = $("#qts_select option:selected").val();
		//notifyUser($('#qts_input').val() + $('#qts_input').text(),'debug');
		jsonw["WorkspaceProfile"]["Querysets"][id]["name"] = $('#qts_input').val();
			
		$("#qts_select option:selected").text( $('#qts_input').val());
		saveWorkspace("USER");
	});
	$('#qts_add').click(function(){
		var new_name = "new_queryset";
		
		var id = $('#qts_select option').size();
		var dt = new Date();
		var str_time = dt.toString("yyyy-MM-dd HH:mm:ss");
		
		if (id == 0){
			jsonw["WorkspaceProfile"]["Querysets"] = [{}];
		}
	
		jsonw["WorkspaceProfile"]["Querysets"][id] = {"name":new_name,"created":str_time , "Queries" : "null"};
		
		saveWorkspace("USER");
		//todo
		
		//loadWorkspace(jsonw["WorkspaceProfile"]["Querysets"]);
		$("#qts_select").append(new Option(new_name, id));
		$("#qts_select").find('option').attr("selected","false");
		$("#qts_select").find('option').last().attr("selected","true");
		$('#qts_input').val(new_name);
	});
	$('#qts_delete').click(function(){
		var count = $("#qts_select option").size();
		
		//if (count > 1){
			var id = parseInt($("#qts_select option:selected").val());
			var size = jsonw["WorkspaceProfile"].Querysets.length;
		
			for (var i=id;i<size-1;i++){
				jsonw["WorkspaceProfile"].Querysets[i] = jsonw["WorkspaceProfile"].Querysets[i+1];
			}
		
			delete jsonw["WorkspaceProfile"].Querysets[size-1];
			jsonw["WorkspaceProfile"]["Querysets"].length = size-1;
			// set null string , if 0 querysets
			if (count == 1) {
				jsonw["WorkspaceProfile"]["Querysets"] = "null";
			}
			saveWorkspace("USER");
			//$("#qts_select option").remove();
			loadQuerysets(jsonw["WorkspaceProfile"]["Querysets"],"user");
			
		//}
	});
	
	$('#collections .cmd_load').live('click',function(event){
		hideWelcomeMessage();
		var collection_text = "";
		var coll = $(this).next().next().next();
		collections.splice(0, collections.length);
		collections[0] = new Collection($(coll).attr("handle"), $(coll).html());
		var columns = columns_widget.getColumnsListText();//$('#columns_list').attr("value");
		var query = new Query(collections,columns,"","");
		query.repository = getSelectedRepository();
	
		//searchclauseset.clear();
		queryset.addquery(query);
		//$('#collection_list').attr("value",query.getcollectiontext("name"));
		collections_widget.load(query.collection);
	
	});
	$('#serverqueries .cmd_load').live('click',function(event){
		
		var id = parseInt( $("#serverqts_select option:selected").val());
		var str = $(this).parent().find('a').attr("href");
		var iq = parseInt(str.substring(9));
		var json = jQuery.parseJSON($("#serverqs").attr("data"));
		var q = json["WorkspaceProfile"]["Querysets"][id]["Queries"][iq];
		
		loadQuery(q);
	});
	$('#userqueries .cmd_load').live('click',function(event){
		
		var id = parseInt( $("#qts_select option:selected").val());
		var str = $(this).parent().find('a').attr("href");
		var iq = parseInt(str.substring(7));
		var q = jsonw["WorkspaceProfile"]["Querysets"][id]["Queries"][iq];
		
		loadQuery(q);
	});
	$('#userqueries .cmd_del').live('click', function(event){
		//var count = $("#userqueries li").size();
		var id = parseInt($("#qts_select option:selected").val());
		var str = $(this).parent().find('a').attr("href");
		var iq = parseInt(str.substring(7));
		var size = jsonw["WorkspaceProfile"]["Querysets"][id]["Queries"].length;
		
		for (var i=iq;i<size-1;i++){
			jsonw["WorkspaceProfile"]["Querysets"][id]["Queries"][i] = jsonw["WorkspaceProfile"]["Querysets"][id]["Queries"][i+1];
		}
	
		delete jsonw["WorkspaceProfile"]["Querysets"][id]["Queries"][size-1];
		jsonw["WorkspaceProfile"]["Querysets"][id]["Queries"].length = size-1;
		
		if (size == 1){
			jsonw["WorkspaceProfile"]["Querysets"][id]["Queries"] = "null";
		}
		
		saveWorkspace("USER");
		loadQuerysets(jsonw["WorkspaceProfile"]["Querysets"],"user");
		//$("#qs_select option").remove();
		//$("#qs_select option").first().attr("selected","true");
	});

	
	$('.ui-dialog-titlebar-del').live('click', function(event){
		//$('#detail-float').dialog('close');
		var t = $(this).parents('.ui-widget').children('.ui-dialog-content');
		$(t).dialog('close');
	});

	$('.ui-dialog-titlebar-up').live('click', function(event){
		var t = $(this).parents('.ui-widget').children('.ui-dialog-content');
		
		$(this).parents('.ui-widget').attr("tempheight",$(this).parents('.ui-widget').height());
		//notifyUser("up(height):" + $(this).parents('.ui-widget').height(),'debug');
		$(this).parents('.ui-widget').height(30);
		//notifyUser("up(tempheight):" + $(this).parents('.ui-widget').attr("tempheight"),'debug');
		
		
		//$(t).find(".ui-dialog-buttonpane:first, .ui-dialog-content").stop({clearQueue:true}).fadeOut(300);
		//$(t).stop({clearQueue:true}).animate({height:'0px'},300);
		
		$(this).removeClass('cmd_up ui-dialog-titlebar-up');
		$(this).addClass('cmd_down ui-dialog-titlebar-down');	
	});
	$('.ui-dialog-titlebar-down').live('click', function(event){
		var t = $(this).parents('.ui-widget').children('.ui-dialog-content');
		
		var h = $(this).parents('.ui-widget').attr("tempheight");
		//notifyUser("down(tempheight):" + h,'debug');
		$(this).parents('.ui-widget').height(parseInt(h));
		//notifyUser("down(height):" + $(this).parents('.ui-widget').height(),'debug');
		
		
		//$(this).parents('.ui-widget').attr("tempheight",$(this).parents('.ui-widget').height());
		//$(t).find(".ui-dialog-content, .ui-dialog-buttonpane:first").stop({clearQueue:true}).fadeIn(800)
		//.end().stop({clearQueue:true}).animate({height:'100%'},300);

		$(this).removeClass('cmd_down ui-dialog-titlebar-down');
		$(this).addClass('cmd_up ui-dialog-titlebar-up');	
	});

	

}
function loadQuery(q){
	if (q["bookmark"] == "1") {
		var uri = "http://localhost:8080/MDService2/record/htmldetail/" + q["querystring"];
		$.get(uri, showDetail,'html');
	} else {
		hideWelcomeMessage();
		var query = new Query([],"","","");
		query.load(q);
		query.repository = getSelectedRepository();
		queryset.addquery(query);
		
		searchclauseset.sctext = query.query;
		notifyUser(searchclauseset.sctext,'debug');
		searchclauseset.buildfromquerystring();

		collections = query.collection;
		collections_widget.load(query.collection);
		columns_widget.load(query.columns.split(','));
		$('#input-simplequery').attr("value",query.squery);
	} 

}
function addVisuals(){
////////////VISUALS 
	
//	$('#left-menu').addClass('ui-accordion ui-widget ui-helper-reset ui-accordion-icons');	
	$('.cmds-ui-block').addClass('ui-helper-reset ui-corner-all');
	$('.cmds-ui-block .header').addClass('ui-widget-header ui-state-default ui-corner-top');
	$('.cmds-ui-block .content').addClass('ui-widget-content ui-corner-bottom');
	$('.cmds-ui-block .header').click(function() {
		$(this).next().toggle('fast');
		return false;
	}).next().hide();

	$('.cmds-ui-block.init-show .header').next().show();
	
	/*
	// Accordion
			$("#left-menu").accordion({ header: "h2",event: 'click' });				
			$("#left-menu").accordion('option', 'autoHeight', false);			
			// hack to open the accordion without scroll-bars on init
			$("#left-menu").accordion('option', 'active', 1);
	*/		
			
				//$("#main-menu").treeview();
			
	// Detail				
	//			$("#detail").tabs("add", "#components","Tab1");
			$("#detail-float").dialog({ autoOpen: false,
				position: ['right','70px'],
				height: 450,
				width: 300,
				minHeigh: 100});

			//$('#detail-float').dialog( "option", "minHeight", '0px' );
			
			$("#detail-float").dialog();
			$("#detail-float").tabs();
			
			/// notify-messages
			$("#notify-float").dialog({ autoOpen: false,
				position: ['right','10px'],
				height: 200,
				width: 400,
				minHeigh: 100});			
			$("#notify-float").dialog();
			$("#notify-float").tabs();

}

function getUrlVars()
{
    var vars = [], hash;
    var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
    for(var i = 0; i < hashes.length; i++)
    {
        hash = hashes[i].split('=');
        vars.push(hash[0]);
        vars[hash[0]] = hash[1];
    }
    return vars;
}

String.prototype.beginsWith = function(t, i) { if (i==false) { return 
	 (t == this.substring(0, t.length)); } else { return (t.toLowerCase() 
	 == this.substring(0, t.length).toLowerCase()); } } ;


String.prototype.endsWith = function(t, i) { if (i==false) { return (t 
	 == this.substring(this.length - t.length)); } else { return 
	 (t.toLowerCase() == this.substring(this.length - 
	 t.length).toLowerCase()); } } ;


 var Url = {
		 
			// public method for url encoding
		encode : function (string) {
			return escape(this._utf8_encode(string));
		},
	 
		// public method for url decoding
		decode : function (string) {
			return this._utf8_decode(unescape(string));
		},
	 
		// private method for UTF-8 encoding
		_utf8_encode : function (string) {
			string = string.replace(/\r\n/g,"\n");
			var utftext = "";
	 
			for (var n = 0; n < string.length; n++) {
	 
				var c = string.charCodeAt(n);
	 
				if (c < 128) {
					utftext += String.fromCharCode(c);
				}
				else if((c > 127) && (c < 2048)) {
					utftext += String.fromCharCode((c >> 6) | 192);
					utftext += String.fromCharCode((c & 63) | 128);
				}
				else {
					utftext += String.fromCharCode((c >> 12) | 224);
					utftext += String.fromCharCode(((c >> 6) & 63) | 128);
					utftext += String.fromCharCode((c & 63) | 128);
				}
	 
			}
	 
			return utftext;
		},
	 
		// private method for UTF-8 decoding
		_utf8_decode : function (utftext) {
			var string = "";
			var i = 0;
			var c = c1 = c2 = 0;
	 
			while ( i < utftext.length ) {
	 
				c = utftext.charCodeAt(i);
	 
				if (c < 128) {
					string += String.fromCharCode(c);
					i++;
				}
				else if((c > 191) && (c < 224)) {
					c2 = utftext.charCodeAt(i+1);
					string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
					i += 2;
				}
				else {
					c2 = utftext.charCodeAt(i+1);
					c3 = utftext.charCodeAt(i+2);
					string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
					i += 3;
				}
	 
			}
	 
			return string;
		}
	 
};